<template>
    <v-layout justify-center row>
        <v-flex sm12 md9 lg7 v-bind:class="containerClasses" class="elevation-4 white text-xs-center" shrink>
            <h1>Info</h1>
            <div class="content">
                <v-layout justify-center row>
                    <v-flex xs12 class="elevation-4 pa-3 ma-1 white text-xs-center" shrink>
                        <h3>Liikmed</h3>
                        <v-data-table
                                :headers="headers"
                                :items="members"
                        >

                            <template slot="no-data">
                                <v-progress-linear v-show="isLoading === true"
                                                   :indeterminate="true"></v-progress-linear>
                                <v-alert :value="true" v-if="!isLoading" color="error" icon="warning">
                                    Liikmed puuduvad
                                </v-alert>
                            </template>

                            <template slot="items" slot-scope="props">
                                <td class="standardText">{{ props.item.name }}</td>
                                <td class="standardText">{{ props.item.job_title }}</td>
                                <td><span v-if="user.role === 'admin'">
                                    <i @click="deleteModerator(props.item.id)"
                                       class="material-icons redhover">delete</i>
                                </span></td>
                            </template>

                        </v-data-table>
                    </v-flex>
                </v-layout>
                <v-layout justify-center row>
                    <v-flex xs12 class="elevation-4 pa-3 ma-1 white text-xs-center" shrink>
                        <h3>Õpilasesindusest</h3>
                        <p>{{ this.infoData.infoDescription }}
                            <v-progress-circular
                                    v-show="isLoading === true"
                                    indeterminate
                                    color="primary"
                            ></v-progress-circular>
                            <v-btn fab small color="primary"
                                   v-if="user.role === 'admin' && !this.edit.infoDescription">
                                <i class="material-icons ml2" v-if="user.role === 'admin'"
                                   @click="edit.infoDescription = !edit.infoDescription">
                                    create
                                </i>
                            </v-btn>
                            <v-flex v-if="edit.infoDescription === true">
                                <v-text-field
                                        v-model="infoData.infoDescription"
                                        label="Uus kirjeldus"
                                        :rules="descriptionRules"
                                ></v-text-field>
                                <v-btn color="primary" small fab>
                                    <i class="material-icons"
                                       @click="change('infoDescription', infoData.infoDescription, user.role)">
                                        check
                                    </i>
                                </v-btn>
                                <v-btn color="error" fab small @click="edit.infoDescription = !edit.infoDescription">
                                    <i class="material-icons">
                                        clear
                                    </i>
                                </v-btn>
                            </v-flex>
                        </p>
                    </v-flex>
                </v-layout>
                <v-layout justify-center row>
                    <v-flex xs12 class="elevation-4 pa-3 ma-1 white text-xs-center" shrink>
                        <h3>Varem lõpetatud projektid</h3>
                        <p>{{ this.infoData.infoProjects }}
                            <v-progress-circular
                                    v-show="isLoading === true"
                                    indeterminate
                                    color="primary"
                            ></v-progress-circular>
                            <v-btn fab small color="primary"
                                   v-if="user.role === 'admin' && !this.edit.infoProjects">
                                <i class="material-icons ml2" v-if="user.role === 'admin'"
                                   @click="edit.infoProjects = !edit.infoProjects">
                                    create
                                </i>
                            </v-btn>
                            <v-flex v-if="edit.infoProjects === true">
                                <v-text-field
                                        v-model="infoData.infoProjects"
                                        label="Projektid"
                                        :rules="projectRules"
                                ></v-text-field>
                                <v-btn color="primary" small fab>
                                    <i class="material-icons"
                                       @click="change('infoProjects', infoData.infoProjects, user.role)">
                                        check
                                    </i>
                                </v-btn>
                                <v-btn color="error" fab small @click="edit.infoProjects = !edit.infoProjects">
                                    <i class="material-icons">
                                        clear
                                    </i>
                                </v-btn>
                            </v-flex>
                        </p>
                    </v-flex>
                </v-layout>
            </div>
        </v-flex>
    </v-layout>
</template>
<script>
    import axios from "axios";
    import {mapGetters} from "vuex";

    export default {
        name: "Info",

        data() {
            return {
                dialog: false,
                headers: [
                    {text: 'Nimi', value: 'user.name'},
                    {text: 'Rühm', value: 'user.job_title'},
                    {text: '', value: 'delete'},
                ],
                members: [],
                infoData: {
                    infoDescription: '',
                    infoProjects: '',
                },
                error: null,
                success: null,
                isLoading: false,
                isValidated: false,
                edit: {
                    infoDescription: false,
                    infoProjects: false,
                },
                descriptionRules: [
                    validation => !!validation || 'Palun sisestage Õpilasesinduse kirjeldus!',
                ],
                projectRules: [
                    validation => !!validation || 'Palun sisestage varasemalt tehtud projekte!',
                ],
            }
        },
        created() {
            axios.get('api/users/members').then(response => {
                this.members = response.data;
            });
            this.isLoading = true;
            axios.get('api/infoPage').then(response => {
                this.infoData = response.data;
                this.isLoading = false;
            });
        },
        computed: {
            ...mapGetters([
                'user'
            ]),
            containerClasses() {
                const smAnDown = this.$vuetify.breakpoint.smAndDown;

                return {
                    'elevation-4': !smAnDown,
                    'ma-1': !smAnDown,
                    'pa-3': !smAnDown,
                    'ma-0': smAnDown,
                    'pa-0': smAnDown
                }
            }
        },
        methods: {
            deleteModerator(userID) {
                this.print = 'delete';
                axios.delete('api/members/' + userID).then(response => {
                    this.members = this.members.filter(item => item.id !== userID);
                })
            },
            change(key, value, userRole) {
                axios.post('/api/infoPage', {
                    key: key,
                    value: value,
                    userRole: userRole,
                }).then(response => {
                    this.success = response.data.message;
                    this.edit[key] = !this.edit[key];
                });
            }
        }
    }
</script>
<style scoped>
    .standardText {
        font-size: 16px;
    }

    .redhover:hover {
        color: red;
        cursor: pointer;
    }
</style>
